/* jinxFn1.c v.1.0c Aztec C ovr      */
/* Jinx Program Functions            */
/* Written by Wayne Parham           */ 
/* 09/01/2022                        */


#include "stdio.h"
#include "jinx.h"


int in16bitComputerRoom() {                                          /* True in 16-bit computer room */
   if( (currentLocation == 66) || (currentLocation == 104) )
      return( TRUE );                                                /* College has Eclipse C/350 */
   else                                                              /* and Arrow Oil has Nova 4C */
      return( FALSE );
}


int in32bitComputerRoom() {                                          /* True in 32-bit computer room */
   if( currentLocation == 53 )
      return( TRUE );                                                /* Tech Center has MV/8000 */
   else
      return( FALSE );
}


int inComputerRoom() {                                               /* True in computer room */
   if( in16bitComputerRoom() || in32bitComputerRoom() )
      return( TRUE );
   else
      return( FALSE );
}


int inHouse( location ) int location; {                              /* True if here: */
   if( ( (location >   1) && (location <   8) )    ||                /* House 5843    */
       ( (location >  30) && (location <  37) )    ||                /* House 3017    */
       ( (location >  72) && (location <  79) )    ||                /* House 4735    */
       ( (location >  85) && (location <  94) )                      /* House 3750    */
     )
      return( TRUE );
   else
      return( FALSE );
}


int isActiveBusiness( location ) int location; {                     /* True if here: */
   if( ( (location >  39) && (location <  46) )    ||                /* Elephant Run  */
       ( (location >  49) && (location <  55) )    ||                /* Tech Center   */
       ( (location >  62) && (location <  70) )    ||                /* College       */
       ( (location > 100) && (location < 108) )                      /* Arrow Oil     */
     )
      return( TRUE );
   else
      return( FALSE );
}


int Indoors( location ) int location; {                              /* True if indoors */
   if( isActiveBusiness(location) || inHouse(location) ) 
      return( TRUE );
   else
      return( FALSE );
}


int Underground( location ) int location; {                          /* True if underground */
   if( location > 133 ) 
      return( TRUE );
   else
      return( FALSE );
}


int isAbandonedBusiness() {                                          /* True if here:   */
   if( (currentLocation ==  48) ||                                   /* Holiday Hills   */
       (currentLocation ==  27) ||                                   /* Southroads Mall */
       (currentLocation ==  80) ||                                   /* Fontana         */
       (currentLocation ==  22) ||                                   /* Coin Shop       */
       (currentLocation ==   9) ||                                   /* Apartments      */
       (currentLocation ==   8) ||                                   /* Old School      */
       (currentLocation ==  49) ||                                   /* Hospital        */
       (currentLocation ==  10) ||                                   /* Telex           */
       (currentLocation ==  62) ||                                   /* Pro Shop        */
       (currentLocation ==  84) ||                                   /* Old School      */
       (currentLocation == 118) )                                    /* Jinx Shops      */
      return( TRUE );
   else
      return( FALSE );
}


void printElapsedTime() {                                            /* Print elapsed time */
   ovloader( "jinxPrET" );
}


int chance() {                                                       /* Get random number betwen 0 and 99 */
   return( rand() );
}


void distribute() {                                                  /* Distribute randomly-placed items */
   ovloader( "jinxDist" );
}


char* getName() {                                                    /* Get object name from keyboard buffer */
   int sp;
   char* item;

   bufferToLower();

   item = blank;

   sp = index(buffer, ' ');
   if (sp != NOTFOUND) {
      item = sp + 1;
      sp = index(item, ' ');
      if( sp != NOTFOUND ) {
         *sp = 0;
      }
   }

   return( item );
}


char* itemName( i ) int i; {                                         /* Returns item name */
   if( i == 11 )
      return( matchesRn );
   else if( i == 13 )
      return( topRn );
   else if( i == 14 )
      return( gneratorRn );
   else if( i == 15 )
      return( gasolinRn );
   else if( i == 20 )
      return( bottleRn );
   else if( i == 21 )
      return( breadRn );
   else if( i == 22 )
      return( meatRn );
   else
      return( Item[i] );
}


void showItemsHere( verbose ) int verbose; {                         /* Show items at current location */
   ovloader( "jinxShow", verbose );
}


void showWhereYouCanGo() {                                           /* Show what directions are available */
   int i;
   int loc;

   printf( youcango );

   for( i = North; i <= Down; i++ ) {
      loc = Move[currentLocation][i];
      if( loc != NOWHERE ) {
         printf( sps, Direction[i] );
      }
   }
   printf( Cr );
}


int carryLoad() {                                                    /* Tells how much you're carrying */
   int i;
   int l;
   l = 0;

   for( i = 0; i <= LastItem; i++ ) {
      if( Inventory[i] != NOTHING ) {
         l += size[Inventory[i]];
      }
   }
   return( l );
}


int matNotMoved() {                                                  /* Check to see if the mat was ever moved */
   return( !getState(1) );
}


void matMoved() {                                                    /* Mat has been moved */
   setState(1);
   locationOfItem[Key] = H3017Porch;
   printf( s, matmoved );
}


int wraithsEliminated() {                                            /* Check to see if the wraiths have been eliminated */
   return( getState(2) );
}


void eliminateWraiths() {                                            /* Eliminate all wraiths */
   setState(2);
}


int flooded() {                                                      /* Check to see if the world was ever flooded */
   return( getState(3) );
}


void setFlooded() {                                                  /* Indicate that the world has been flooded */
   setState(3);
   if( wraithAgitation < 60 )
      wraithAgitation += 10;
}


int swordFound() {                                                   /* Check to see if sword found */
   return( getState(4) );
}


void foundSword() {                                                  /* Sword has been moved */
   setState(4);
   if( wraithAgitation < 60 )
      wraithAgitation += 10;
}


int goneInRoom() {                                                   /* Check to see if we've ever been in wraith house */
   return( getState(5) );
}


void enterRoom() {                                                   /* Went into wraith house */
   setState(5);
   if( wraithAgitation < 60 )
      wraithAgitation += 10;
}


int wraithAttacking() {                                              /* Check to see if wraith is attacking */
   if( wraithEncounters & 128 )
      return( TRUE );
   else
      return( FALSE );
}


void havingWraithEncounter( encounter ) int encounter; {             /* Record the wraith encounter event */
   wraithEncounters = (wraithEncounters / 2) + (encounter * 128);
}


void unlock3017FrontDoor() {                                         /* Unlock house 3017 front door */
   Move[30][North] = 31;
   printf( s, unlocked );
}


int is3017FrontDoorUnlocked() {                                      /* See if front door is unlocked */
   if( Move[30][North] == 31 )
      return( TRUE );
   else
      return( FALSE );
}


void unlck3017Shelter() {                                            /* Unlock house 3017 shelter */
   Move[37][North] = 38;
   Move[38][South] = 37;
   printf( s, unlocked );
}


int is3017ShelterUnlocked() {                                        /* See if shelter is unlocked */
   if( Move[37][North] == 38 )
      return( TRUE );
   else
      return( FALSE );
}


void open4735Hatch() {                                               /* Open house 4735 garage hatch */
   Move[78][Down] = 140;
   Move[140][Up] = 78;
   printf( s, opened );
}


int isHatchOpen() {                                                  /* See if hatch is open */
   if( Move[78][Down] == 140 )
      return( TRUE );
   else
      return( FALSE );
}


void openForestGrate() {                                             /* Open forest grate */
   Move[121][Down] = 142;
   Move[142][Up] = 121;
   printf( s, opened );
}


int isGrateOpen() {                                                  /* See if grate is open */
   if( Move[121][Down] == 142 )
      return( TRUE );
   else
      return( FALSE );
}


int carryingItem( item ) char* item; {                               /* True if carrying specified item */
   int i;

   for( i = 0; i <= LastItem; i++ ) {
      if( (Inventory[i] != NOTHING) && (!strcmp(Item[Inventory[i]], item)) )
         return( TRUE );
   }
   return( FALSE );
}


int itemIsHere( item ) char* item; {                                 /* True if item at current location */
   int i;

   for( i = 1; i <= LastItem; i++ ) {
      if( !strcmp(item, Item[i]) ) {
         if( locationOfItem[i] == currentLocation ) {
            return( TRUE );
         } else {
            return( FALSE );
         }
      }
   }
   return( FALSE );
}


void increaseAgitation() {                                           /* Increase wraith agitation */
   if( carryingItem(ring) )
      turnsToAgitate = RINGAGITATEFREQUENCY;
   else
      turnsToAgitate = DEFAULTAGITATEFREQUENCY;
   if( ! (turnsPlayed % turnsToAgitate) )
      wraithAgitation++;
}


void killWraith() {                                                  /* Kill wraith with sword */
   havingWraithEncounter( FALSE );
   if( wraithStrength > KILLVALUE )
      wraithStrength = wraithStrength - KILLVALUE;
   if( wraithAgitation > KILLVALUE )
      wraithAgitation = wraithAgitation - KILLVALUE;
   printf( sCr, deadbeef );
}


int jinxStat( verbose ) int verbose; {                               /* Retrieve score information */
   return( ovloader( "jinxStat", verbose ) );
}


void gameOver() {                                                    /* Set WorldState to "game over" */
   clearState(0);
   printf( gameover, turnsPlayed );
   if( (minutesPassed > 0) || (hoursPassed > 0) ) {
      printf( elapsedtimewas );
      printElapsedTime();
      printf( dot );
   }
   jinxStat( DETAILED );
}


void flood() {                                                       /* Flood the world */
   ovloader( "jinxFld" );
}


void wraithAction() {                                                /* Now it's the wraith's turn */
   ovloader( "jinxWraT" );
}


void checkFate() {                                                   /* External events */
   int points;
   int seed;

   if( strlen(buffer) == 0 )
      return;

   if( turnsPlayed == 11 ) {                                         /* Distribute randomly-placed items */
      points = jinxStat( QUIET );
      seed = ( (minutesPassed+1) * (points+1) );
      srand( seed );
      distribute();
   }

   if( !flooded()    &&                                              /* Check the weather */
     ( turnFlood != UNINITIALIZED) && (turnsPlayed == turnFlood) ) {
      flood();
   }

   if( running() )
      wraithAction();                                                /* See what the wraiths are doing */
}


int haveKey() {                                                      /* Do we have the key? */
   return( carryingItem( key ) );
}


void printLocation( verbose ) int verbose; {                         /* Print current location */
   if( visited[currentLocation] && !verbose ) {
      printf( sCr, Location[currentLocation] );
   } else {
      printf( youare, Location[currentLocation] );
      if( Descript[currentLocation] )
         printf( s, Descript[currentLocation] );
      printf( dotCr );
   }
}
