/* jinxFn3.c v.1.0c Aztec C ovr      */
/* Jinx Program Functions            */
/* Written by Wayne Parham           */ 
/* 09/01/2022                        */


#include "stdio.h"
#include "jinx.h"


void openDoor() {                                                    /* Open door */
   ovloader( "jinxOpen" );
}


void pray() {                                                        /* Pray */
   ovloader( "jinxPray" );
}


void quit() {                                                        /* Quit prompt */
   printf( sureyouwanttoquit );
#ifndef TINY
   fgets( buffer, SCREENWIDTH-1, stdin );
#else
   gets( buffer );
#endif
   if( tolower(buffer[0]) == 'y' ) {
      gameOver();
   }
}


void readWords() {                                                   /* Read */
   ovloader( "jinxRead" );
}


void ringbell() {                                                    /* Ring (bell) */
   ovloader( "jinxRing" );
}


void speak() {                                                       /* Speak */
   if( strlen( buffer ) > 4 )
      printf( quoted, buffer+4 );
   else
      printf( blahblah );
   turnsPlayed++;
}


void status() {                                                      /* Status */
   printf( sofaryouplayed, turnsPlayed );
   if( (minutesPassed > 0) || (hoursPassed > 0) ) {
      printf( in );
      printElapsedTime();
   }
   printf( dot );
   jinxStat( DETAILED );
}


void type() {                                                        /* Type */
   ovloader( "jinxType" );
}


void unlock() {                                                      /* Unlock door */
   ovloader( "jinxUnlk" );
}


void prompt() {                                                      /* Prompt for player input */
   printf( inp );
#ifndef TINY
   fgets( buffer, SCREENWIDTH-1, stdin );
   buffer[strlen(buffer)-1] = '\0';
#else
   gets( buffer );
#endif
}


void playerAction() {                                                /* Parse command and do it */
   int len;
   len = strlen( buffer );

   if( len == 0 ) {
      return;
   }
   else if( len == 1 ) {
      buffer[0] = tolower( buffer[0] );
      if( buffer[0] == 'h' ) {                                       /* help */
         help();
      }
      else if( buffer[0] == 'i' ) {                                  /* inventory */
         inventory();
      }
      else if( buffer[0] == 'l' ) {                                  /* look */
         look();
      }
      else if( (buffer[0] == 'n') ||                                 /* travel */
               (buffer[0] == 's') ||
               (buffer[0] == 'e') ||
               (buffer[0] == 'w') ||
               (buffer[0] == 'u') ||
               (buffer[0] == 'd') )
      {
         travel();
      }
      else {
         printf( s, badParse );
      }
   }
   else if( len == 2 ) {
      buffer[1] = tolower( buffer[1] );
      if( buffer[0] == 'n' ) {
         if( (buffer[1] == 'e') || (buffer[1] == 'w') ) {
            travel();
         }
         else {
            printf( s, badParse );
         }
      }
      else if( buffer[0] == 's' ) {
         if( (buffer[1] == 'e') || (buffer[1] == 'w') ) {
            travel();
         }
         else {
            printf( s, badParse );
         }
      }
      else if( (buffer[0] == 'u') && (buffer[1] == 'p') ) {
            travel();
      }
      else {
         printf( s, badParse );
      }
   }
   else if( !strncasecmp(buffer, "go up", 5) ) {
      buffer[0] = 'u';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "down", 4)) || (!strncasecmp(buffer, "go down", 7)) ) {
      buffer[0] = 'd';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "northeast", 9)) || (!strncasecmp(buffer, "go northeast", 12)) ) {
      buffer[0] = 'n';
      buffer[1] = 'e';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "northwest", 9)) || (!strncasecmp(buffer, "go northwest", 12)) ) {
      buffer[0] = 'n';
      buffer[1] = 'w';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "southeast", 9)) || (!strncasecmp(buffer, "go southeast", 12)) ) {
      buffer[0] = 's';
      buffer[1] = 'e';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "southwest", 9)) || (!strncasecmp(buffer, "go southwest", 12)) ) {
      buffer[0] = 's';
      buffer[1] = 'w';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "north", 5)) || (!strncasecmp(buffer, "go north", 8)) ) {
      buffer[0] = 'n';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "south", 5)) || (!strncasecmp(buffer, "go south", 8)) ) {
      buffer[0] = 's';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "east", 4)) || (!strncasecmp(buffer, "go east", 7)) ) {
      buffer[0] = 'e';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "west", 4)) || (!strncasecmp(buffer, "go west", 7)) ) {
      buffer[0] = 'w';
      buffer[1] = '\0';
      travel();
   }
   else if( !strncasecmp(buffer, "drink", 5) ) {                     /* drink */
      drink();
   }
   else if( !strncasecmp(buffer, "drop every", 10) ) {               /* drop everything */
      dropall();
   }
   else if( !strncasecmp(buffer, "drop all", 8) ) {                  /* drop all */
      dropall();
   }
   else if( !strncasecmp(buffer, "drop", 4) ) {                      /* drop */
      drop();
   }
   else if( !strncasecmp(buffer, "eat", 3) ) {                       /* eat */
      eat();
   }
   else if( !strncasecmp(buffer, "enter", 5) ) {                     /* enter */
      openDoor();
   }
   else if( !strncasecmp(buffer, "examine", 7) ) {                   /* examine */
      examine();
   }
   else if( !strncasecmp(buffer, "get every", 9) ) {                 /* get everything */
      getall();
   }
   else if( !strncasecmp(buffer, "get all", 7) ) {                   /* get all */
      getall();
   }
   else if( !strncasecmp(buffer, "get", 3) ) {                       /* get */
      get();
   }
   else if( !strncasecmp(buffer, "help", 4) ) {                      /* help */
      help();
   }
   else if( !strncasecmp(buffer, "inv", 3) ) {                       /* inventory */
      inventory();
   }
   else if( !strncasecmp(buffer, "kill", 4) ) {                      /* kill */
      attack();
   }
   else if( !strncasecmp(buffer, "light", 5) ) {                     /* light */
      light();
   }
   else if( !strncasecmp(buffer, "load", 4) ) {                      /* load */
      loadGameState();
      status();
      look();
   }
   else if( !strncasecmp(buffer, "look", 4) ) {                      /* look */
      look();
   }
   else if( !strncasecmp(buffer, "move", 4) ) {                      /* move */
      move();
   }
   else if( !strncasecmp(buffer, "open", 4) ) {                      /* open */
      openDoor();
   }
   else if( !strncasecmp(buffer, "pray", 4) ) {                      /* pray */
      pray();
   }
   else if( !strncasecmp(buffer, "quit", 4) ) {                      /* quit */
      quit();
   }
   else if( !strncasecmp(buffer, "read", 4) ) {                      /* read */
      readWords();
   }
   else if( !strncasecmp(buffer, "ring", 4) ) {                      /* ring */
      ringbell();
   }
   else if( !strncasecmp(buffer, "save", 4) ) {                      /* save */
      saveGameState();
   }
   else if( !strncasecmp(buffer, "say", 3) ) {                       /* say */
      speak();
   }
   else if( !strncasecmp(buffer, "score", 5) ) {                     /* score */
      status();
   }
   else if( !strncasecmp(buffer, "take every", 10) ) {               /* take everything (get everything) */
      getall();
   }
   else if( !strncasecmp(buffer, "take all", 8) ) {                  /* take all (get all) */
      getall();
   }
   else if( !strncasecmp(buffer, "take", 4) ) {                      /* take (get) */
      get();
   }
   else if( !strncasecmp(buffer, "type", 4) ) {                      /* type */
      type();
   }
   else if( !strncasecmp(buffer, "unlock", 6) ) {                    /* unlock */
      unlock();
   }
   else {
      printf( s, badParse );
   }
}
