/* jinxLoad.c v.1.0c Aztec C ovr     */
/* LoadGameState()                   */
/* Written by Wayne Parham           */ 
/* 09/01/2022                        */


#include "stdio.h"
#include "jinx.h"


void ovmain() {                                                      /* Load Game State */
   int i;
   FILE *loadFile;

   loadFile = fopen( "jinx.sav", "r" );

   if( loadFile == NULL ) {
      printf( "\nError opening jinx.sav file.  Perhaps one was never created.\n\n" );   
      return;             
   } else {
      fread( &saveState, sizeof(saveState), 1, loadFile );
#ifndef TINY 
      if( ferror ( loadFile ) ) {
         printf( "\nError reading jinx.sav file.\n\n" );
      } else {
#else
      {
#endif
         WorldState       = saveState.WorldState;
         currentLocation  = saveState.curLoc;
         turnsPlayed      = saveState.turnsP;
         turnFlood        = saveState.turnF;
         turnCandle       = saveState.turnC;
         turnBell         = saveState.turnR;
         turnBook         = saveState.turnB;
         minutesPassed    = saveState.minsPassed;
         hoursPassed      = saveState.hrsPassed;
         wraithEncounters = saveState.wraithE;
         wraithStrength   = saveState.wraithS;
         wraithAgitation  = saveState.wraithA;
         turnsToAgitate   = saveState.turnsTA;
         Move[30][North]  = saveState.Move30N;
         Move[37][North]  = saveState.Move37N;
         Move[38][South]  = saveState.Move38S;
         Move[78][Down]   = saveState.Move78D;
         Move[140][Up]    = saveState.Move140U;
         Move[121][Down]  = saveState.Move121D;
         Move[142][Up]    = saveState.Move142U;

         for( i=1; i<=LastLocation; i++ ) { 
            visited[i]    = saveState.vis[i];
         }

         for( i=1; i<=LastItem; i++ ) {
            Inventory[i]  = saveState.inv[i];
         }

         for( i=1; i<=LastItem; i++ ) {
            locationOfItem[i] = saveState.loc[i];
         }

         if( flooded() ) {                                           /* If saved game had flooded */
            for( i = 29; i < 38; i++ ) {                             /* then remove house 3017    */
               Location[i] = muddyarea;
               Descript[i] = NULL;
            }
            Descript[31] = scattereddebris;                          /* and litter with debris    */
         }

         printf( "\nPrevious game restored.\n" );
      }

      fclose( loadFile );
   }

   return;
}
