/* jinxRead.c v.1.0c Aztec C ovr     */
/* readWords()                       */
/* Written by Wayne Parham           */ 
/* 09/01/2022                        */


#include "stdio.h"
#include "jinx.h"


void examine() {                                                     /* Examine item */
   int i;                                                            /* Same as examine() in jinxExmn.c */
   char* item;                                                       /* No need to jump out and back    */

   item = getName();

   if( !strcmp(item, all) ) {                                        /* disallow "examine all" */
      printf( s, oneatatime );
      return;
   }
   else if( !strcmp(item, gas) )                                     /* allows "examine gas"   */
      item = gasoline;
   else if( !strcmp(item, match) )                                   /* allows "examine match" */
      item = matches;

   turnsPlayed++;
   timeElapsed( 1 );

   if( (currentLocation == Campus3) && (!strcmp(item, building)) ) {
      printf( s, tallbuilding );
      return;
   }

   for( i = 0; i <= LastItem; i++ ) {                                /* scan for item in inventory          */
      if( (Inventory[i] != NOTHING) && (!strcmp(Item[Inventory[i]], item)) ) {
         if( Detail[Inventory[i]][0] ) {
            printf( s, Detail[Inventory[i]] );                       /* print item detail, if there is any  */
	 } else {
            printf( ordinaryitem, itemName(Inventory[i]) );          /* else print item name                */
         }
         return;
      }
   }

   for( i = 1; i <= LastItem; i++ ) {                                /* see if it's at the current location */
      if( !strcmp(item, Item[i]) ) {
         if( locationOfItem[i] == currentLocation ) {
            if( Detail[i][0] ) {
               printf( s, Detail[i] );                               /* print item detail, if there is any  */
	    } else {
               printf( ordinaryitem, itemName(i) );                  /* else print item name                */
            }
            return;
         }
      }
   }                                                                 /* if item not found */

   printf( nothingfound );                                           /* then print that   */
}


void ovmain() {                                                      /* Read */
   char* item;

   item = getName();

   if( strlen( buffer ) < 6 ) {
      printf( s, badParse );
      return;
   }

   turnsPlayed++;
   timeElapsed( 1 );

   if( !strcmp(item, book) ) {
      if( carryingItem(book) || itemIsHere(book) ) {
         turnBook = turnsPlayed;
         printf( s, prayer );
      } else {
         printf( s, nothingfound );
      }
      return;
   }
   else if( (!strcmp(item, parchment)) ||
            (!strcmp(item, rock))      ||
            (!strcmp(item, notice))    ||
            (!strcmp(item, magazine))  ||
            (!strcmp(item, newspaper)) ||
            (!strcmp(item, brochure))
          ) {
      examine();
      return;
   }
   printf( s, readnothing );
}
