/* jinxSave.c v.1.0c Aztec C ovr     */
/* SaveGameState()                   */
/* Written by Wayne Parham           */ 
/* 09/01/2022                        */


#include "stdio.h"
#include "jinx.h"


void ovmain() {                                                      /* Save Game State */
   int i;
   FILE *saveFile;

   saveFile = fopen( "jinx.sav", "w" );

   if( saveFile == NULL ) {
      printf( "\nError creating jinx.sav file.\n\n" );   
      return;             
   } else {

      saveState.WorldState   = WorldState;
      saveState.curLoc       = currentLocation;
      saveState.turnsP       = turnsPlayed;
      saveState.turnF        = turnFlood;
      saveState.turnC        = turnCandle;
      saveState.turnR        = turnBell;
      saveState.turnB        = turnBook;
      saveState.minsPassed   = minutesPassed;
      saveState.hrsPassed    = hoursPassed;
      saveState.wraithE      = wraithEncounters;
      saveState.wraithS      = wraithStrength;
      saveState.wraithA      = wraithAgitation;
      saveState.turnsTA      = turnsToAgitate;
      saveState.Move30N      = Move[30][North];
      saveState.Move37N      = Move[37][North];
      saveState.Move38S      = Move[38][South];
      saveState.Move78D      = Move[78][Down];
      saveState.Move140U     = Move[140][Up];
      saveState.Move121D     = Move[121][Down];
      saveState.Move142U     = Move[142][Up];

      for( i=1; i<=LastLocation; i++ ) { 
         saveState.vis[i]    = visited[i];
      }

      for( i=1; i<=LastItem; i++ ) {
         saveState.inv[i]    = Inventory[i];
      }

      for( i=1; i<=LastItem; i++ ) {
         saveState.loc[i]    = locationOfItem[i];
      }

      fwrite( &saveState, sizeof(saveState), 1, saveFile );
#ifndef TINY
      if( ferror ( saveFile ) ) {
         printf( "\nError writing jinx.sav file.\n\n" );     
      } else {
#else
      {
#endif
         printf( "\nSaved.\n" );
      }

      fclose( saveFile );
   }

   return;
}
