/* jinxFn2.c v1.0b Altair BDS C      */
/* Jinx Program Functions            */
/* Written by Wayne Parham           */ 
/* 08/28/2022                        */


#include <stdio.h>
#include "jinx.h"


void attack() {                                                      /* Attack (kill) */
   char* target;

   target = getName();

   if( strlen( buffer ) < 6 ) {
      printf( s, badParse );
      return;
   }

   turnsPlayed++;
   timeElapsed( 1 );

   if( !strcmp( target, wraith ) ) {
      if( ! wraithAttacking() ) {
         printf( seeno, wraith );
         return;
      }
      else {
         if( carryingItem(sword) ) {
            killWraith();
         }
         else {
            printf( s, noweapon );
         }
      }
      return;
   }
   printf( s, nopoint );
}


void drink() {                                                       /* Drink */
   char* item;

   item = getName();

   if( (strlen(buffer)) == 5 || (!strcmp(item, water)) || (!strcmp(item, bottle)) ) {
      if( carryingItem(bottle) || itemIsHere(bottle) ) {
         printf( sCr, ahh );
      }
      else {
         printf( sCr, nothingpalatable );
      }
   }
   else {
      printf( sCr, nasty );
   }
}


void drop() {                                                        /* Drop item */
   int i;
   char* item;

   item = getName();

   if( !strcmp(item, gas) )
      item = gasoline;
   else if( !strcmp(item, match) )
      item = matches;

   turnsPlayed++;

   for( i = 0; i <= LastItem; i++ ) {                                /* scan for item in inventory   */
      if( (Inventory[i] != NOTHING) && (!strcmp(Item[Inventory[i]], item)) ) {
         locationOfItem[Inventory[i]] = currentLocation;             /* put item in current location */
         Inventory[i] = NOTHING;                                     /* remove from inventory        */
         printf( dropped, item );
         return;
      }
   }

   printf( notcarrying, item );
}


void dropall() {                                                     /* Drop everything */
   int i;
   int haveitems;

   haveitems = FALSE;

   for( i = 0; i <= LastItem; i++ ) {
      if( (Inventory[i] != NOTHING) ) {
         sprintf( buffer, dropss, Item[Inventory[i]] );
         drop();
         haveitems = TRUE;
      }
   }
   if( !haveitems )
      printf( notcarrying, "anything" ); 
}


void eat() {                                                         /* Eat */
   char* item;

   item = getName();

   if( ((strlen(buffer)) == 3) || (!strcmp(item, bread)) || (!strcmp(item, meat)) ) {
      if( carryingItem(bread) || itemIsHere(bread) || carryingItem(meat) || itemIsHere(meat) ) { 
         printf( sCr, mmm );
      }
      else {
         printf( sCr, nothingpalatable );
      }
   }
   else {
      printf( sCr, nasty );
   }
}


void examine() {                                                     /* Examine item */
   int i;
   char* item;

   item = getName();

   if( !strcmp(item, all) ) {                                    /* disallow "examine all" */
      printf( s, oneatatime );
      return;
   }
   else if( !strcmp(item, gas) )                                 /* allows "examine gas"   */
      item = gasoline;
   else if( !strcmp(item, match) )                               /* allows "examine match" */
      item = matches;

   turnsPlayed++;
   timeElapsed( 1 );

   if( (currentLocation == Campus3) && (!strcmp(item, building)) ) {
      printf( s, tallbuilding );
      return;
   }

   for( i = 0; i <= LastItem; i++ ) {                                /* scan for item in inventory          */
      if( (Inventory[i] != NOTHING) && (!strcmp(Item[Inventory[i]], item)) ) {
         if( Detail[Inventory[i]][0] ) {
            printf( s, Detail[Inventory[i]] );                       /* print item detail, if there is any  */
	 } else {
            printf( ordinaryitem, itemName(Inventory[i]) );          /* else print item name                */
         }
         return;
      }
   }

   for( i = 1; i <= LastItem; i++ ) {                                /* see if it's at the current location */
      if( !strcmp(item, Item[i]) ) {
         if( locationOfItem[i] == currentLocation ) {
            if( Detail[i][0] ) {
               printf( s, Detail[i] );                               /* print item detail, if there is any  */
	    } else {
               printf( ordinaryitem, itemName(i) );                  /* else print item name                */
            }
            return;
         }
      }
   }                                                                 /* if item not found */

   printf( nothingfound );                                           /* then print that   */
}


void get() {                                                         /* Get item */
   int i;
   int j;
   char* item;

   item = getName();

   if( !strcmp(item, gas) )
      item = gasoline;
   else if( !strcmp(item, match) )
      item = matches;

   if( carryingItem(item) ) {                                        /* if we already have it, say so */
      printf( alreadyHave );
      return;
   }

   turnsPlayed++;

   for( i = 1; i <= LastItem; i++ ) {                                /* scan for item                     */
      if( !strcmp(item, Item[i]) ) {
         if( locationOfItem[i] == currentLocation ) {                /* if the item is here               */
            if( size[i] == IMMOVABLE ) {
               printf( cannotmove, item );
               if( i == Statue ) {
                  printf( s, groundshakes );
                  if( !flooded() ) {
                     printf( sdotCr, rainbegins );
                     flood();
                  }
                  else {
                     printf( dotCr );
                  }
               }
               return;
            }
            else if( size[i] + carryLoad() > MAXCARRYSIZE ) {        /* and not too much to carry         */
               printf( s, toomuch );
               return;
            }
            else {
               if( (i == Notice) && (currentLocation == 12) ) {
                  Descript[12] = NULL;
               }
               for( j = 0; j <= LastItem; j++ ) {
                  if( Inventory[j] == NOTHING ) {
                     Inventory[j] = i;                               /* put item in inventory             */
                     locationOfItem[i] = NOWHERE;                    /* remove item from current location */
                     printf( got, item );
                     if( !strcmp(item, mat) && matNotMoved() ) {
                        matMoved();
                     }
                     if( (i == Sword) && !swordFound() ) {           /* sword increases wraith agitation  */
                        foundSword();
                     }
                     return;
                  }
               }
            }
         }
      }
   }
   if( isActiveBusiness( currentLocation ) )
      printf( s, nopoint );
   else
      printf( seeno, item );
}


void getall() {                                                      /* Get everything */
   int i;
   int itemsfound;

   itemsfound = FALSE;

   for( i = 1; i <= LastItem; i++ ) {
      if( locationOfItem[i] == currentLocation ) {
         sprintf( buffer, getss, Item[i] );
	 get();
	 itemsfound = TRUE;
      }
   }
   if( !itemsfound )
      printf( s, getnothing ); 
}


void help() {                                                        /* Print help screen */
   printf( s, helpString );
}


void inventory() {                                                   /* List of items held */
   int i;
   int found;

   found = FALSE;

   printf( s, youarecarrying );
   for( i = 0; i <= LastItem; i++ ) {
      if( Inventory[i] != NOTHING ) {
         printf( spsCr, Item[Inventory[i]] );
         found = TRUE;
      }
   }

   if( !found )
      printf( nothing );
}


void light() {                                                       /* Light (matches or candle) */
   char* item;

   item = getName();

   if( strlen( buffer ) < 7 ) {
      printf( s, badParse );
      return;
   }

   turnsPlayed++;

   if( !strcmp(item, candle) ) {
      if( (carryingItem(candle)  || itemIsHere(candle))    &&
          (carryingItem(matches) || itemIsHere(matches) )
        ) {
         turnCandle = turnsPlayed;
         printf( s, lightcandle );
      } else {
         if( ! (carryingItem(candle)  || itemIsHere(candle)) )
            printf( seeno, candle );
         if( ! (carryingItem(matches) || itemIsHere(matches)) )
            printf( seeno, matches );
      }
      return;
   }
   else if( !strcmp(item, match) ) {
      if( carryingItem(matches) || itemIsHere(matches) ) {
         printf( s, lightmatch );
      } else {
         printf( seeno, matches );
      }
      return;
   }
   printf( s, nopoint );
}


void look() {                                                        /* Print description of surroundings */
   printLocation( DETAILED );
   showItemsHere( DETAILED );
   showWhereYouCanGo();
}


void move() {
   char* object;

   object = getName();

   timeElapsed( 1 );
   turnsPlayed++;

   if( (currentLocation == H3017Porch) && matNotMoved() && (!strcmp(object, mat)) ) {
       matMoved();
   }
   else if( (currentLocation == Mountn2) && (!strcmp(object, rock)) ) {
       printf( cannotmove, rock );
       return;
   }
   else if( (currentLocation == JinxCentre) && (!strcmp(object, statue)) ) {
       printf( cannotmove, statue );
       printf( s, groundshakes );
       if( !flooded() ) {
          printf( sdotCr, rainbegins );
          flood();
       }
       else {
          printf( dotCr );
       }
       return;
   }
   else
      printf( s, nopoint );
}


void travel() {                                                      /* Travel */
   int d;
   int len;

   d = 0;
   len = strlen( buffer );

   if( buffer[0] == 'u' ) {
      d = Up;
   } else if( buffer[0] == 'd' ) {
      d = Down;
   } else if( buffer[0] == 'w' ) {
      d = West;
   } else if( buffer[0] == 'e' ) {
      d = East;
   } else if( buffer[0] == 'n' ) {
      if( len == 1 ) {
         d = North;
      } else {
         if( buffer[1] == 'w' ) {
            d = Northwest;
         } else {
            d = Northeast;
         }
      }
   } else if( buffer[0] == 's' ) {
      if( len == 1 ) {
         d = South;
      } else {
         if( buffer[1] == 'w' ) {
            d = Southwest;
         } else {
            d = Southeast;
         }
      }
   }

   if( Move[currentLocation][d] == UNAVAILABLE ) {
      if( (currentLocation == H3017Porch) && (d == North) ) {
         if( haveKey() ) {
            printf( s, usingkey );
            unlock3017FrontDoor();
         } else {   
            printf( s, doorlocked );
            return;
         }
      }
      else if( (currentLocation == H3017BackYard) && (d == North) ) {
         if( haveKey() ) {
            visited[134] = FALSE;
            printf( s, usingkey );
            unlck3017Shelter();
         } else {   
            printf( s, doorlocked );
            return;
         }
      }
      else if( (currentLocation == H4735Garage) && (d == Down) ) {
         visited[140] = FALSE;
         printf( s, openhatch );
         open4735Hatch();
      }
      else if( (currentLocation == ForestClearing) && (d == Down) ) {
         visited[142] = FALSE;
         printf( s, opengrate );
         openForestGrate();
      }
      else if( (currentLocation == Below4735Garage) && (d == Up) ) {
         printf( s, closedhatch );
         return;
      }
      else if( (currentLocation == BelowGrate) && (d == Up) ) {
         printf( s, closedgrate );
         return;
      } else {   
         printf( youcannotgo, Direction[d] );
         return;
      }
   }

   currentLocation = Move[currentLocation][d];
   if( visited[currentLocation] == FALSE ) {
      printLocation( DETAILED );
      showItemsHere( NORMAL );
      visited[currentLocation] = TRUE;
   } else {
      printLocation( NORMAL );
   }

   if( (currentLocation == H3750Bedroom) && !goneInRoom() ) {
      enterRoom();
   }

   checkAreas();

   turnsPlayed++;
   if( Indoors( currentLocation ) )
      timeElapsed( 1 );
   else
      timeElapsed( 3 );
}
