/* jinxFn3.c v.1.0b Altair BDS C     */
/* Jinx Program Functions            */
/* Written by Wayne Parham           */ 
/* 08/28/2022                        */


#include <stdio.h>
#include "jinx.h"


void open() {                                                        /* Open door */
   turnsPlayed++;
   if( currentLocation == H3017Porch ) {
      if( is3017FrontDoorUnlocked() ) {
         printf( s, alreadyopen );
         currentLocation = H3017EntryHall;
      } else {
         if( haveKey() ) {
            printf( s, usingkey );
            unlock3017FrontDoor();
            currentLocation = H3017EntryHall;
         } else {   
            printf( s, doorlocked );
         }
      }
      return;
   }
   else if( currentLocation == H3017Front ) {
      currentLocation = H3017Porch;
      buffer[0] = 'n';
      buffer[1] = '\0';
      travel();
   }
   else if( currentLocation == H3017BackYard ) {
      if( is3017ShelterUnlocked() ) {
         printf( s, alreadyopen );
         currentLocation = H3017Shelter;
      } else {
         if( haveKey() ) {
            visited[134] = FALSE;
            printf( s, usingkey );
            unlck3017Shelter();
            currentLocation = H3017Shelter;
         } else {   
            printf( s, doorlocked );
         }
      }
      return;
   }
   else if( currentLocation == H5843Front ) {
      buffer[0] = 'n';
      buffer[1] = '\0';
      travel();
      return;
   }
   else if( currentLocation == H4735Front ) {
      buffer[0] = 'e';
      buffer[1] = '\0';
      travel();
      return;
   }
   else if( currentLocation == H3750Front ) {
      buffer[0] = 's';
      buffer[1] = '\0';
      travel();
      return;
   }
   else if( currentLocation == H4735Garage ) {
      if( isHatchOpen() ) {
         printf( s, alreadyopen );
      } else {
         visited[140] = FALSE;
         printf( s, openhatch );
         open4735Hatch();
      }
      return;
   }
   else if( currentLocation == ForestClearing ) {
      if( isGrateOpen() ) {
         printf( s, alreadyopen );
      } else {
         visited[142] = FALSE;
         printf( s, opengrate );
         openForestGrate();
      }
      return;
   }
   else if( currentLocation == Below4735Garage ) {
      if( isHatchOpen() )
         printf( s, alreadyopen );
      else
         printf( s, closedhatch );
      return;
   }
   else if( currentLocation == BelowGrate ) {
      if( isGrateOpen() )
         printf( s, alreadyopen );
      else
         printf( s, closedgrate );
      return;
   }
   else if( isAbandonedBusiness() ) {
      printf( s, barred );
      return;
   } else {
      printf( nothingtoopen );
      return;
   }
}


void pray() {                                                        /* Pray */
   if( turnsPlayed > 10 )
      timeElapsed( (chance() % 3) * -1 );

   if( (currentLocation == Church) &&
       (turnsPlayed == turnBook) &&                                  /* Did we light the candle, */
       (turnBook == turnBell + 1) &&                                 /*     ring the bell and    */
       (turnBell == turnCandle + 1)                                  /*     read the book?       */
     ) {
      eliminateWraiths();
      printf( s, voiceofGod );
   } 
}


void quit() {                                                        /* Quit prompt */
   printf( sureyouwanttoquit );
   fgets( buffer, SCREENWIDTH-1, stdin );
   if( tolower(buffer[0]) == 'y' ) {
      GameOver();
   }
}


void readWords() {                                                   /* Read */
   char* item;

   item = getName();

   if( strlen( buffer ) < 6 ) {
      printf( s, badParse );
      return;
   }

   turnsPlayed++;
   timeElapsed( 1 );

   if( !strcmp(item, book) ) {
      if( carryingItem(book) || itemIsHere(book) ) {
         turnBook = turnsPlayed;
         printf( s, prayer );
      } else {
         printf( s, nothingfound );
      }
      return;
   }
   else if( (!strcmp(item, parchment)) ||
            (!strcmp(item, rock))      ||
            (!strcmp(item, notice))    ||
            (!strcmp(item, magazine))  ||
            (!strcmp(item, newspaper)) ||
            (!strcmp(item, brochure))
          ) {
      examine();
      return;
   }
   printf( s, readnothing );
}


void ringbell() {                                                    /* Ring (bell) */
   char* item;

   item = getName();

   if( strlen( buffer ) < 6 ) {
      printf( s, badParse );
      return;
   }

   turnsPlayed++;

   if( !strcmp(item, bell) ) {
      if( carryingItem(bell) || itemIsHere(bell) ) {
         turnBell = turnsPlayed;
         printf( quoted, ring );
      }
      else {
         printf( seeno, bell );
      }
   }
   else {
      printf( s, nopoint );
   }
}


void speak() {                                                       /* Speak */
   if( strlen( buffer ) > 4 )
      printf( quoted, buffer+4 );
   else
      printf( blahblah );
   turnsPlayed++;
}


void status() {                                                      /* Status */
   printf( sofaryouplayed, turnsPlayed );
   if( (minutesPassed > 0) || (hoursPassed > 0) ) {
      printf( in );
      printElapsedTime();
   }
   printf( dot );
   printf( printpointsearned, pointsEarned(), maxPoints() );
}


void type() {                                                        /* Type */
   char* phrase;
   int r;

   phrase = getName();
   r = chance();

   if( inComputerRoom() ) {
      if( !strcmp(phrase, xyzzy) ) {
         if( in16bitComputerRoom() )
            printf( screensaysnothinghappens );
         else if( in32bitComputerRoom() )
            printf( twiceasmuchhappens );
      } else {
         printf( frontpanelflickers );
         if( r < 30 )
            printf( dotCr );
         else if( (r > 30) && (r < 70) )
            printf( diskshakes );
         else
            printf( tapemoves );
      }
   } else {
     printf( noComputer );
   }
   turnsPlayed++;
}


void unlock() {                                                      /* Unlock door */
   if( currentLocation == H3017Porch ) { 
      if( is3017FrontDoorUnlocked() ) {
         printf( s, notlocked );
      }
      else {
         if( haveKey() )
            open();
         else
            printf( s, needkey );
      }
      return;
   }
   else if( currentLocation == H3017BackYard ) {
      if( is3017ShelterUnlocked() ) {
         printf( s, notlocked );
      }
      else {
         if( haveKey() )
            open();
         else
            printf( s, needkey );
      }
      return;
   }
   else if( currentLocation == H4735Garage ) {
      printf( s, notlocked );
      return;
   }
   else if( currentLocation == ForestClearing ) {
      printf( s, notlocked );
      return;
   }
   else if( currentLocation == Below4735Garage ) {
      printf( s, closedhatch );
      return;
   }
   else if( currentLocation == BelowGrate ) {
      printf( s, closedgrate );
      return;
   }
   else if( isAbandonedBusiness() ) {
      printf( s, barred );
      return;
   } else {
      printf( unlocknothing );
      return;
   }
}


void prompt() {                                                      /* Prompt for player input */
   printf( inp );
   fgets( buffer, SCREENWIDTH-1, stdin );
   buffer[strlen(buffer)-1] = '\0';
}


void playerAction() {                                                /* Parse command and do it */
   int len;
   len = strlen( buffer );

   if( len == 0 ) {
      return;
   }
   else if( len == 1 ) {
      buffer[0] = tolower( buffer[0] );
      if( buffer[0] == 'h' ) {                                       /* help */
         help();
      }
      else if( buffer[0] == 'i' ) {                                  /* inventory */
         inventory();
      }
      else if( buffer[0] == 'l' ) {                                  /* look */
         look();
      }
      else if( (buffer[0] == 'n') ||                                 /* travel */
               (buffer[0] == 's') ||
               (buffer[0] == 'e') ||
               (buffer[0] == 'w') ||
               (buffer[0] == 'u') ||
               (buffer[0] == 'd') )
      {
         travel();
      }
      else {
         printf( s, badParse );
      }
   }
   else if( len == 2 ) {
      buffer[1] = tolower( buffer[1] );
      if( buffer[0] == 'n' ) {
         if( (buffer[1] == 'e') || (buffer[1] == 'w') ) {
            travel();
         }
         else {
            printf( s, badParse );
         }
      }
      else if( buffer[0] == 's' ) {
         if( (buffer[1] == 'e') || (buffer[1] == 'w') ) {
            travel();
         }
         else {
            printf( s, badParse );
         }
      }
      else if( (buffer[0] == 'u') && (buffer[1] == 'p') ) {
            travel();
      }
      else {
         printf( s, badParse );
      }
   }
   else if( !strncasecmp(buffer, "go up", 5) ) {
      buffer[0] = 'u';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "down", 4)) || (!strncasecmp(buffer, "go down", 7)) ) {
      buffer[0] = 'd';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "northeast", 9)) || (!strncasecmp(buffer, "go northeast", 12)) ) {
      buffer[0] = 'n';
      buffer[1] = 'e';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "northwest", 9)) || (!strncasecmp(buffer, "go northwest", 12)) ) {
      buffer[0] = 'n';
      buffer[1] = 'w';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "southeast", 9)) || (!strncasecmp(buffer, "go southeast", 12)) ) {
      buffer[0] = 's';
      buffer[1] = 'e';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "southwest", 9)) || (!strncasecmp(buffer, "go southwest", 12)) ) {
      buffer[0] = 's';
      buffer[1] = 'w';
      buffer[2] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "north", 5)) || (!strncasecmp(buffer, "go north", 8)) ) {
      buffer[0] = 'n';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "south", 5)) || (!strncasecmp(buffer, "go south", 8)) ) {
      buffer[0] = 's';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "east", 4)) || (!strncasecmp(buffer, "go east", 7)) ) {
      buffer[0] = 'e';
      buffer[1] = '\0';
      travel();
   }
   else if( (!strncasecmp(buffer, "west", 4)) || (!strncasecmp(buffer, "go west", 7)) ) {
      buffer[0] = 'w';
      buffer[1] = '\0';
      travel();
   }
   else if( !strncasecmp(buffer, "drink", 5) ) {                     /* drink */
      drink();
   }
   else if( !strncasecmp(buffer, "drop every", 10) ) {               /* drop everything */
      dropall();
   }
   else if( !strncasecmp(buffer, "drop all", 8) ) {                  /* drop all */
      dropall();
   }
   else if( !strncasecmp(buffer, "drop", 4) ) {                      /* drop */
      drop();
   }
   else if( !strncasecmp(buffer, "eat", 3) ) {                       /* eat */
      eat();
   }
   else if( !strncasecmp(buffer, "enter", 5) ) {                     /* enter */
      open();
   }
   else if( !strncasecmp(buffer, "examine", 7) ) {                   /* examine */
      examine();
   }
   else if( !strncasecmp(buffer, "get every", 9) ) {                 /* get everything */
      getall();
   }
   else if( !strncasecmp(buffer, "get all", 7) ) {                   /* get all */
      getall();
   }
   else if( !strncasecmp(buffer, "get", 3) ) {                       /* get */
      get();
   }
   else if( !strncasecmp(buffer, "help", 4) ) {                      /* help */
      help();
   }
   else if( !strncasecmp(buffer, "inv", 3) ) {                       /* inventory */
      inventory();
   }
   else if( !strncasecmp(buffer, "kill", 4) ) {                      /* kill */
      attack();
   }
   else if( !strncasecmp(buffer, "light", 5) ) {                     /* light */
      light();
   }
#ifdef ENBLSAVE
   else if( !strncasecmp(buffer, "load", 4) ) {                      /* load */
      loadGameState();
      status();
      look();
   }
#endif
   else if( !strncasecmp(buffer, "look", 4) ) {                      /* look */
      look();
   }
   else if( !strncasecmp(buffer, "move", 4) ) {                      /* move */
      move();
   }
   else if( !strncasecmp(buffer, "open", 4) ) {                      /* open */
      open();
   }
   else if( !strncasecmp(buffer, "pray", 4) ) {                      /* pray */
      pray();
   }
   else if( !strncasecmp(buffer, "quit", 4) ) {                      /* quit */
      quit();
   }
   else if( !strncasecmp(buffer, "read", 4) ) {                      /* read */
      readWords();
   }
   else if( !strncasecmp(buffer, "ring", 4) ) {                      /* ring */
      ringbell();
   }
#ifdef ENBLSAVE
   else if( !strncasecmp(buffer, "save", 4) ) {                      /* save */
      saveGameState();
   }
#endif
   else if( !strncasecmp(buffer, "say", 3) ) {                       /* say */
      speak();
   }
   else if( !strncasecmp(buffer, "score", 5) ) {                     /* score */
      status();
   }
   else if( !strncasecmp(buffer, "take every", 10) ) {               /* take everything (get everything) */
      getall();
   }
   else if( !strncasecmp(buffer, "take all", 8) ) {                  /* take all (get all) */
      getall();
   }
   else if( !strncasecmp(buffer, "take", 4) ) {                      /* take (get) */
      get();
   }
   else if( !strncasecmp(buffer, "type", 4) ) {                      /* type */
      type();
   }
   else if( !strncasecmp(buffer, "unlock", 6) ) {                    /* unlock */
      unlock();
   }
   else {
      printf( s, badParse );
   }
}
