/* jinxIni4.c v.1.0a Altair BDS C    */
/* Initializer for Jinx              */
/* Written by Wayne Parham           */ 
/* 08/28/2022                        */


#include <stdio.h>
#include "jinx.h"


/* Map: Given a location and a direction to move, returns the location it connects                                       */
/*      or 0 if not a valid move.  Map can change during game play.                                                      */
/*                                                                                                                       */
void initMap1() {
/*                                                                                                                       */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move,        "0,    0,    0,    0,    0,    0,    0,    0,    0,    0" );  /*  0 Nowhere                       */
   initw( Move[1],     "2,   16,   19,    0,   12,    0,    8,    0,    0,    0" );  /*  1 H5843Front                    */
   initw( Move[2],     "5,    0,    6,    0,    1,    0,    3,    0,    0,    0" );  /*  2 H5843EntryHall                */
   initw( Move[3],     "4,    0,    2,    0,    0,    0,    0,    0,    0,    0" );  /*  3 H5843Garage                   */
   initw( Move[4],     "0,    0,    5,    0,    3,    0,    0,    0,    0,    0" );  /*  4 H5843Kitchen                  */
   initw( Move[5],     "0,    0,    0,    0,    2,    0,    4,    0,    0,    0" );  /*  5 H5843LivingRoom               */
   initw( Move[6],     "0,    0,    0,    0,    0,    0,    2,    0,    7,    0" );  /*  6 H5843Stairs                   */
   initw( Move[7],     "0,    0,    0,    0,    0,    0,    0,    0,    0,    6" );  /*  7 H5843Bedroom                  */
   initw( Move[8],     "9,   10,    1,   11,    0,    0,   46,    0,    0,    0" );  /*  8 OldSchl1                      */
   initw( Move[9],    "27,    0,   10,    0,    8,    0,   39,    0,    0,    0" );  /*  9 Apartments                    */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move[10],   "22,   13,   16,   19,    0,    8,    9,    0,    0,    0" );  /*  10 TelexFactory                 */
   initw( Move[11],    "0,   19,    0,   61,   25,    0,   47,    8,    0,    0" );  /*  11 Nbhood3                      */
   initw( Move[12],    "1,    0,   19,    0,    0,    0,    8,   16,    0,    0" );  /*  12 LampPost                     */
   initw( Move[13],    "0,   23,   14,   17,   16,   10,   22,    0,    0,    0" );  /*  13 OpnFld6                      */
   initw( Move[14],    "0,   24,   15,   18,   17,   16,   13,   23,    0,    0" );  /*  14 OpnFld7                      */
   initw( Move[15],    "0,    0,   50,    0,   18,   17,   14,   24,    0,    0" );  /*  15 OpnFld8                      */
   initw( Move[16],   "13,   14,   17,   20,   19,    1,   10,   22,    0,    0" );  /*  16 OpnFld9                      */
   initw( Move[17],   "14,   15,   18,   21,   20,   19,   16,   13,    0,    0" );  /*  17 OpnFld10                     */
   initw( Move[18],   "15,    0,    0,    0,   21,   20,   17,   14,    0,    0" );  /*  18 OpnFld11                     */
   initw( Move[19],   "16,   17,   20,   70,   60,   11,    1,   10,    0,    0" );  /*  19 OpnFld12                     */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move[20],   "17,   18,   21,    0,   70,   60,   19,   16,    0,    0" );  /*  20 OpnFld13                     */
   initw( Move[21],   "18,    0,   56,   57,   72,   70,   20,   17,    0,    0" );  /*  21 OpnFld14                     */
   initw( Move[22],    "0,    0,   13,   16,   10,    0,    0,    0,    0,    0" );  /*  22 CoinShop                     */
   initw( Move[23],    "0,    0,   24,   14,    0,   13,    0,    0,    0,    0" );  /*  23 Nhills1                      */
   initw( Move[24],    "0,    0,    0,   15,    0,   14,   23,    0,    0,    0" );  /*  24 Nhills2                      */
   initw( Move[25],   "11,    0,   61,    0,   26,   49,    0,    0,    0,    0" );  /*  25 OpnFld4                      */
   initw( Move[26],   "25,    0,   63,   79,    0,   95,    0,    0,    0,    0" );  /*  26 OpnFld5                      */
   initw( Move[27],   "28,    0,    0,    0,    9,    0,    0,    0,    0,    0" );  /*  27 SouthroadsMall               */
   initw( Move[28],    "0,    0,   27,    0,   39,   42,   29,    0,    0,    0" );  /*  28 Nbhood1                      */
   initw( Move[29],   "30,    0,   28,    0,    0,    0,    0,    0,    0,    0" );  /*  29 H3017Front                   */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move[30],   "31,    0,    0,    0,   29,    0,    0,    0,    0,    0" );  /*  30 H3017Porch                   */
   initw( Move[31],   "33,    0,   34,    0,   30,    0,   32,    0,    0,    0" );  /*  31 H3017EntryHall               */
   initw( Move[32],    "0,    0,   31,    0,    0,    0,    0,    0,    0,    0" );  /*  32 H3017SittingRoom             */
   initw( Move[33],   "36,    0,    0,    0,   31,    0,    0,    0,    0,    0" );  /*  33 H3017Kitchen                 */
   initw( Move[34],    "0,    0,   35,    0,    0,    0,   31,    0,    0,    0" );  /*  34 H3017Hall                    */
   initw( Move[35],    "0,    0,    0,    0,    0,    0,   34,    0,    0,    0" );  /*  35 H3017Bedroom                 */
   initw( Move[36],    "0,    0,    0,    0,   33,    0,   37,    0,    0,    0" );  /*  36 H3017LivingRoom              */
   initw( Move[37],   "38,    0,   36,    0,    0,    0,    0,    0,    0,    0" );  /*  37 H3017BackYard                */
   initw( Move[38],    "0,    0,    0,    0,   37,    0,    0,    0,    0,  134" );  /*  38 H3017Shelter                 */
   initw( Move[39],   "40,   28,    9,    0,   46,    0,   94,    0,    0,    0" );  /*  39 OpnFld1                      */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move[40],   "41,    0,    0,    0,   39,    0,    0,    0,    0,    0" );  /*  40 ElphRunFront                 */
   initw( Move[41],   "42,    0,   45,    0,   40,    0,   44,    0,    0,    0" );  /*  41 ElphRunHall                  */
   initw( Move[42],   "28,    0,    0,    0,   41,    0,    0,    0,    0,    0" );  /*  42 ElphRunBack                  */
   initw( Move[43],    "0,    0,   44,    0,    0,    0,    0,    0,    0,    0" );  /*  43 ElphRunKitchen               */
   initw( Move[44],    "0,    0,   41,    0,    0,    0,   43,    0,    0,    0" );  /*  44 ElphRunTables                */
   initw( Move[45],    "0,    0,    0,    0,    0,    0,   41,    0,    0,    0" );  /*  45 ElphRunOffice                */
   initw( Move[46],   "39,    0,    8,    0,   47,    0,    0,    0,    0,    0" );  /*  46 Nbhood2                      */
   initw( Move[47],   "46,    0,   11,    0,   48,    0,    0,    0,    0,    0" );  /*  47 AbandonedAirport             */
   initw( Move[48],   "47,    0,    0,   49,    0,    0,    0,    0,    0,    0" );  /*  48 HollidayHills                */
   initw( Move[49],    "0,   25,    0,    0,    0,    0,    0,   48,    0,    0" );  /*  49 Hospital                     */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move[50],    "0,    0,   51,    0,    0,    0,   15,    0,    0,    0" );  /*  50 TechCntWestDock              */
   initw( Move[51],    "0,    0,   52,    0,    0,    0,   50,    0,    0,    0" );  /*  51 TechCntLab                   */
   initw( Move[52],   "53,    0,    0,    0,   54,    0,   51,    0,    0,    0" );  /*  52 TechCntOffice                */
   initw( Move[53],    "0,    0,    0,    0,   52,    0,    0,    0,    0,    0" );  /*  53 TechCntComputer              */
   initw( Move[54],   "52,    0,    0,    0,   55,    0,    0,    0,    0,    0" );  /*  54 TechCntFront                 */
   initw( Move[55],   "54,    0,    0,    0,   56,    0,    0,    0,    0,    0" );  /*  55 Farm                         */
   initw( Move[56],   "55,    0,    0,    0,   57,    0,   21,    0,    0,    0" );  /*  56 Ehills1                      */
   initw( Move[57],   "56,    0,    0,    0,   58,   71,   72,   21,    0,    0" );  /*  57 Ehills2                      */
   initw( Move[58],   "57,    0,    0,    0,   59,    0,    0,   71,    0,    0" );  /*  58 Ehills3                      */
   initw( Move[59],   "58,    0,    0,    0,    0,   82,   81,   80,    0,    0" );  /*  59 Ehills4                      */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
   initw( Move[60],   "19,   20,    0,    0,   62,    0,    0,    0,    0,    0" );  /*  60 GolfCrs1                     */
   initw( Move[61],   "62,    0,   70,   80,   63,    0,   25,   11,    0,    0" );  /*  61 GolfCrs2                     */
   initw( Move[62],   "60,    0,    0,    0,   61,    0,    0,    0,    0,    0" );  /*  62 ProShop                      */
   initw( Move[63],   "61,    0,   64,   67,   79,   68,   26,    0,    0,    0" );  /*  63 ClgOfficeFront               */
   initw( Move[64],    "0,    0,   65,    0,    0,    0,   63,    0,    0,    0" );  /*  64 ClgReception                 */
   initw( Move[65],   "66,    0,    0,    0,    0,    0,   64,    0,    0,    0" );  /*  65 ClgAdmissions                */
   initw( Move[66],    "0,    0,    0,    0,   65,    0,    0,    0,    0,    0" );  /*  66 ClgAccounting                */
   initw( Move[67],    "0,    0,    0,    0,    0,    0,    0,   63,    0,    0" );  /*  67 Campus1                      */
   initw( Move[68],    "0,   63,    0,    0,   69,    0,    0,    0,    0,    0" );  /*  68 Campus2                      */
   initw( Move[69],   "68,    0,    0,    0,    0,    0,    0,    0,    0,    0" );  /*  69 Campus3                      */
/* ==================   N     NE    E     SE    S     SW    W     NW    U     D   ====================================== */
}
